<?php

namespace Lession\Lession;

use User;

class Lession
{
    /**
     * $lession object.
     */
    protected $lession;

    /**
     * Constructor.
     */
    public function __construct(\Lession\Lession\Interfaces\LessionRepositoryInterface $lession)
    {
        $this->lession = $lession;
    }

    /**
     * Returns count of lession.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.lession.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->lession->pushCriteria(new \Litepie\Lession\Repositories\Criteria\LessionUserCriteria());
        }

        $lession = $this->lession->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('lession::' . $view, compact('lession'))->render();
    }
}
