<?php

namespace Lession\Lession\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class LessionTransformer extends TransformerAbstract
{
    public function transform(\Lession\Lession\Models\Lession $lession)
    {
        return [
            'id'                => $lession->getRouteKey(),
            'key'               => [
                'public'    => $lession->getPublicKey(),
                'route'     => $lession->getRouteKey(),
            ], 
            'id'                => $lession->id,
            'name'              => $lession->name,
            'url'               => [
                'public'    => trans_url('lession/'.$lession->getPublicKey()),
                'user'      => guard_url('lession/lession/'.$lession->getRouteKey()),
            ], 
            'status'            => trans('app.'.$lession->status),
            'created_at'        => format_date($lession->created_at),
            'updated_at'        => format_date($lession->updated_at),
        ];
    }
}