<?php

namespace Lession\Lession\Workflow;

use Lession\Lession\Models\Lession;
use Lession\Lession\Notifications\LessionWorkflow as LessionNotifyer;
use Notification;

class LessionNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Lession $lession
     *
     * @return void
     */
    public function complete(Lession $lession)
    {
        return Notification::send($lession->user, new LessionNotifyer($lession, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Lession $lession
     *
     * @return void
     */
    public function verify(Lession $lession)
    {
        return Notification::send($lession->user, new LessionNotifyer($lession, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Lession $lession
     *
     * @return void
     */
    public function approve(Lession $lession)
    {
        return Notification::send($lession->user, new LessionNotifyer($lession, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Lession $lession
     *
     * @return void
     */
    public function publish(Lession $lession)
    {
        return Notification::send($lession->user, new LessionNotifyer($lession, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Lession $lession
     *
     * @return void
     */
    public function archive(Lession $lession)
    {
        return Notification::send($lession->user, new LessionNotifyer($lession, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Lession $lession
     *
     * @return void
     */
    public function unpublish(Lession $lession)
    {
        return Notification::send($lession->user, new LessionNotifyer($lession, 'unpublish'));;

    }
}
